
      --I  modified  a  Bairstow/Pascal  root  finder  program which I
      --downloaded  from www.vectorbd.com.  It is  an interesting site
      --with lots of electrical engineering files.
      --The changes I made are:
 
      --Changed from Pascal source code to Euphoria source code.
      --Added a root-check-program  using multiplication. If the roots
      --are correct, the original polynomial is returned.
 
      --Some checking has been done. The prog is well behaved but some
      --polynomials are not solveable by this method. I have run it up to
      --an order of 30.
 
      --To use, just run it and follow the prompts.
      --Please report errors or problems to Art Adamson, e-mail
 
      --                  euclid@horandata.net
 
      --Arthur Adamson, Feb. 1997.
 
      --The following notes are from the downloaded file.
 
      --{  Polynomial root Finder - Bairstow Method  }
 
      --{    Written by Jeff Crawford                  September 20, 1984
 
      --                 Transported to TRW 1/17/86
 
      --References :
 
      --[1]  "Applied Numerical Methods for Digital Computation", M. L. James
      --    G. M. Smith, J. C. Wolford, Harper & Row, 1977.
      --[2]  "Applied Numerical Analysis ",
	 --Curtis F. Gerald, Patrick Wheatley
      --Addison-Wesley, Third Edition, 1984.
 
      --The modified code follows:
 
include get.e
with trace
integer      n,          --  Order of Polynomial -  is
	     --  Gradually Reduced During
	     -- the Procedure
	n_save,     --  Same as "n" but retains the
	     --  Value of the Original Order
	j,          --  Counter Used in For Loops
	count,      --  Iteration Counter
	maxSeq     --  Max length of sequence
 
sequence     a, a_save,         --  Coefficient Matrix of Poly
	bn,         --  Coefficients of Reduced Poly
	cn,         --  Partial Derivatives Used
	Re_root,Im_root, -- Real & Imaginary Roots
	Iteration,  --  Number of Iterations Required for each root
	Re_remainder, --  Remainder When Root is Subst
	Im_remainder  --  Remainder When Root is Subst
 
atom         Dummy,       --real  Variable to Receive Input
	u,v,         --real  Variables Used in Iteration
	     --  to Find Roots of Polynomial
	rad,         --real  Number Under Radical
	firstCoeff  --saver for multiplier for check-polynomial
--  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
function sqr(atom a)
    return a*a
end function
 
function abs(atom a)
if a < 1 then a = -a
end if
return a
end function
 
function getnum()
object o
o = get(0)
return  o[2]
end function
 
procedure bn_cn(integer nn) --var a,bn,cn: matrix  n: integer)
	-- Calculates Bn's & Cn's as
	-- Described in [1] above, Eqs. 2-69 & 2-74
atom     delta_u, -- real  Fractional Part Added to Each u Each Iteration
    delta_v, -- real  Fractional Part Added to Each v Each Iteration
    Denom,   -- : real  -- Denominator Used in Masons Rule to Determine
	--           Delta_u and Delta_v
    stat     -- : real  -- Aborts Loop if > 100 Iteration
 
if a[nn-2] != 0.0 then
    u= a[nn-1]/a[nn-2]                 --  Initialize Starting Values
    v= a[nn]/a[nn-2]                   --  Initialize Starting Values
end if
if a[nn-2] = 0.0 then -- If the Above Values are Zero, Starting Values of 0.5
	 --are Used Instead
    u= 0.5
    v= 0.5
end if
delta_u= 1.0
count = 1   stat= 1.0
 
while stat > 1.0e-14 do
 
    bn[1]= 1.0
    bn[2]= a[2] - u
    for i = 3 to nn do  bn[i]= a[i]-bn[i-1]*u - bn[i-2]*v  -- Eq. 2-69 of [1]
    end for
    cn[1]= 1.0
    cn[2]= bn[2] - u
    for i= 3 to nn-1 do cn[i]= bn[i] - cn[i-1]*u - cn[i-2]*v --Eq. 2-74 of [1]
    end for
    if nn <= 4 then Denom= sqr(cn[nn-2])-(cn[nn-1]-bn[nn-1])
       --Eqs.(f),(g)pg.165[1]}
       else Denom= sqr(cn[nn-2])-(cn[nn-1]-bn[nn-1])*cn[nn-3]
    end if
    delta_u= (bn[nn-1]*cn[nn-2] - bn[nn]*cn[nn-3])/Denom
    delta_v= (cn[nn-2]*bn[nn] - (cn[nn-1]-bn[nn-1])*bn[nn-1])/Denom
    u= u + delta_u                            -- Eq. 2-80 of [1]
    v= v + delta_v
    stat = sqrt(delta_u * delta_u + delta_v * delta_v)
    if count >= 300 then stat= 1.0e-14  -- Aborts Loop for excessive Iterations
    end if
    count= count + 1
end while
    Iteration[nn]= count
    Iteration[nn-1]= count
    rad= sqr(u) - 4*v
    if rad >= 0.0 then
    rad= sqrt(rad)
    Re_root[nn-1]= (-u + rad)/2.0
    Re_root[nn]= (-u - rad)/2.0
    Re_remainder[nn-1]= Re_root[nn-1]*bn[nn-1]
    Re_remainder[nn]= Re_remainder[nn-1]
    end if
    if rad < 0.0 then
    rad= -1.0 * rad
    rad= sqrt(rad)
    Re_root[nn-1]= -u/2.0
    Re_root[nn]= Re_root[nn-1]
    Im_root[nn-1]= rad/2.0
    Im_root[nn]= -rad/2.0
    Re_remainder[nn]= (Re_root[nn] + u)*bn[nn-1] + bn[nn]
    Im_remainder[nn]= Im_root[nn]*bn[nn-1]
    Re_remainder[nn-1]= Re_remainder[nn]
    Im_remainder[nn-1]= Im_remainder[nn]
    end if
end procedure
 
-- <<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- begin prog
puts(1,"Enter order of polynomial =   ")
n = getnum() + 1
? n-1
n_save = n
maxSeq = n
a               = repeat(0.0,maxSeq)
a_save          = repeat(0.0,maxSeq)
bn              = repeat(0.0,maxSeq)
cn              = repeat(0.0,maxSeq)
Re_root         = repeat(0.0,maxSeq)
Im_root         = repeat(0.0,maxSeq)
Iteration       = repeat(0.0,maxSeq)
Re_remainder    = repeat(0.0,maxSeq)
Im_remainder    = repeat(0.0,maxSeq)
puts(1,"Enter Polynomial Coefficients (reals only) beginning \n")
puts(1,"with highest power of X\n")
 
for i= 1 to n do
    puts(1,"Enter Coefficient x^")
    printf(1,"%3d",n-i)
    puts(1,"   =   ")
    Dummy = getnum()
    a[i] = Dummy
    printf(1,"%6.10g", Dummy)
    puts(1,"\n")
end for
 
a_save = a
firstCoeff = a[1]
if a[1] != 1.0 then --normalize to first coeff = 1, save it for check-mult
    Dummy= a[1]
    for i= 1 to n do
    a[i]= a[i]/Dummy
    end for
end if
-- Beginning of Root Evaluation  -  First for X to (1) Power, then X to (2)
--   and then for X  Raised to 3 or More Power
 
while 1 > 0 do
 
if n = 2 then   --  Case of Single Real Root
    Re_root[n]= -a[2]/a[1]
    Im_root[n]= 0.0
    Iteration[n]= 1
    n = n - 1
    if n = 1 then  exit end if
    end if
 
if n = 3 then                  -- Calculates Root for Order (n) = 2
    Iteration[n]= 1
    Iteration[n-1]= 1
    rad= sqr(a[2]) - 4*a[1]*a[3]
    if rad >= 0.0 then                 --  Positive Roots
    rad= sqrt(rad)
    Re_root[n-1]= (-a[2]+rad)/(2*a[1])
    Re_root[n]= (-a[2] - rad)/(2*a[1])
    end if
    if rad < 0.0 then      -- Quantity Under Radical is (-) so Complex Roots
    rad= -1.0 * rad
    rad= sqrt(rad)
    Re_root[n-1]= -a[2]/(2*a[1])
    Re_root[n]= Re_root[n-1]
    Im_root[n-1]= rad/(2*a[1])
    Im_root[n]= -rad/(2*a[1])
    end if
    n= n - 2
    if n = 1 then exit end if
    end if
 
    if n >= 4 then        -- Case for Order > 3
    bn_cn(n)
    n = n - 2
    end if
 
    for i= 1 to n do    --  Synthetic Division Performed & Begin With
	  --  New Polynomial for Root Evaluation
    a[i]= bn[i]
    end for
 
end while
 
puts(1,"  Roots of the Polynomial with the following coefficients:\n")
? a_save
puts(1, " by Bairstows Method are (not valid if remainders are not small):\n")
j= n_save
-- Calculation Completed - Output Results
puts(1,"            Real      Imaginary   Iterations       Real      ")
puts(1,"      Imag \n")
puts(1,"                                                 Remainder ")
puts(1,"     Remainder\n")
while j > 1 do
    puts(1,"[")
    printf(1,"%3d", n_save-j+1) puts(1,"] ")
    printf(1,"%11.7g",Re_root[j])
    puts(1,"  ")
    printf(1,"%11.7g", Im_root[j] )
    puts(1,"    ")
    printf(1,"%3g", Iteration[j] )
    puts(1,"         ")
    printf(1,"%10.7g", Re_remainder[j] )
    puts(1,"     ")
    printf(1,"%10.7g", Im_remainder[j] )
    puts(1,"\n")
    j = j - 1
    end while
 
--End of adapted Bairstow. The remainder is original code by Arthur Adamson,
--Feb 8, 1997. It autoloads and checks the preceding Bairstow results.
--It can be returned to a stand alone program with user input of roots
--by uncommenting the appropriate lines.
 
puts(1,"Type ^C & CR to quit or 1 & CR to check result by multiplying.")
? getnum()     --simply to introduce a delay for user viewing of the
--Bairstow results
 
--Below is a checking prog...by multiplication of terms of the form
--(x- r1 -i1)(x-r2-i2)(r3-i3).... * firstCoeff
 
--Purpose, check the roots of a polynomial in x by multiplying to hopefully
--recreate the original polynomial. The original is assumed to have 1.0
--as the first coefficient (high order term). The multiplication is of the
--form (x-1realPart + i*1imagPart)*(x-2realPart + i*2imagPart)* etc...
 
include get.e
sequence realParts, imagParts, realCoeffs, tempRCoeffs,
		imagCoeffs, tempICoeffs
    --realParts is an array of floats
    --representing the real parts of n roots for an n degree polynomial
 
    --realCoeffs will contain the real part of therecreated polynomial
    --coefficients in the form realCoeffs = {c1,c2,c3,....}
    --imagCoeffs will contain the imaginary parts of the coeffs.
    --The coefficient imaginary part should be 0, at least for now since I
    --have no plans for complex coefficients. Even so, the check
    --multiplication should verify that the complex roots multiply out to
    --give only real coefficients.
 
atom numRoots
 
--function getn()
    --object o
    --o = get(0)
    --return o[2]
--end function
 
--puts(1,"Please input the roots. How many roots?  ")
--numRoots = getn()
--? numRoots
numRoots = n_save
 
realParts = repeat(0.0,numRoots)
imagParts = repeat(0.0,numRoots)
realCoeffs = repeat(0.0, numRoots+1)
tempRCoeffs = repeat(0.0, numRoots+1)
tempICoeffs = repeat(0.0, numRoots+1)
imagCoeffs = repeat(0.0, numRoots+1)
 
realParts = Re_root
imagParts = Im_root
 
    --for j = 1 to numRoots by 1 do
   --puts(1,"Input the root realPart and CR  = ")
   --realParts[j] = getn()
   --? realParts[j]
   --
   --puts(1,"Input the imaginaryPart CR      = ")
   --imagParts[j] = getn()
   --? imagParts[j]
 
    --end for
--? realParts
 
--puts(1,"The recreated real and imaginary parts of the polynomial\n")
--puts(1,"coefficients produced by multiplying (x-root1)*(x-root2)... are\n")
realCoeffs[1] = 1.0                   --4 lines to initialize
realCoeffs[2] = -realParts[1]
imagCoeffs[1] = 0.0
imagCoeffs[2] = -imagParts[1]
 
--Now multiply by the x - root factors
for i = 2 to numRoots do
tempRCoeffs = realCoeffs
tempICoeffs = imagCoeffs
 
  realCoeffs[2..numRoots+1] = tempRCoeffs[2..numRoots+1] --by x terms
   - tempRCoeffs[1..numRoots] * (realParts[i])  --by RRoot terms
   + tempICoeffs[1..numRoots] * (imagParts[i])  --by i*i terms
 
  imagCoeffs[2..numRoots+1] = tempICoeffs[2..numRoots+1] --i's by x term
   - tempICoeffs[1..numRoots] * realParts[i]  --i's by RRoot terms
   - tempRCoeffs[1..numRoots] * imagParts[i]   --use r*i terms
 
end for
 
puts(1,"The recreated real coeffs are: \n")
 
for k = 1 to numRoots by 1 do
    printf(1,"%7.9g", (realCoeffs[k] * firstCoeff ))
    puts(1,"   ")
end for
    puts(1,"\nThe imaginaries, which follow (errors), should be near zero: \n")
 
for k = 1 to numRoots by 1 do
    printf(1,"%1.9g", (imagCoeffs[k] * firstCoeff ))
    puts(1,"   ")
end for
puts(1,"\nThe max absolute imaginary coefficient value/error is:  ")
Dummy = 0
for k = 1 to numRoots by 1 do
u = imagCoeffs[k]
u = abs(u)
if u  > Dummy   then
    Dummy = u
end if
end for
    ? (Dummy * firstCoeff)
 
--This is the end
 
